/* ----------------------------------------------------------- */
/* DEMO Name : Digital I/O demo			                           */
/* Compiler  : Turbo C++ 3.0, Mode Large                       */
/* ----------------------------------------------------------- */

#include "PCIFC16.H"
#include <DOS.H>


DWORD dwBaseAddr,dwBaseDIO,dwBaseTimer0,dwBaseTimer1;
WORD wIrq,wModelID,wCardID;

void main()
{
  int  i;
  WORD j;
  WORD wBoards;
  WORD wDIVal,wBoardNo,wRtn;
  char c;

  clrscr();
  wRtn=PCIFC16_DriverInit(&wBoards);
  printf("\n(1)Threr are %d PCI-FC16 Cards in this PC",wBoards);
  if ( wBoards==0 )
  {
	putch(0x07);  putch(0x07);  putch(0x07);
	printf("\n(1) There are no PCI-FC16 card in this PC !!!\n"); exit(0);
  }

  for(i=0; i<wBoards; i++)
  {
	wRtn = PCIFC16_GetConfigAddressSpace(i,&dwBaseAddr,&dwBaseDIO,&dwBaseTimer0,&dwBaseTimer1,&wIrq,&wModelID,&wCardID);
	if (wRtn) printf("\nGetCardInfo Error!!!");
	printf("\n PCI-%4x[%d] dwBaseAddr=%lx, dwBaseDIO=%lx, dwBaseTimer0=%lx, dwBaseTimer1=%lx, wIrq=%x, CardID=%x",wModelID,i,dwBaseAddr,dwBaseDIO,dwBaseTimer0,dwBaseTimer1,wIrq,wCardID);
  }

  printf("\nPlease press any key.");
  getch();

  wBoardNo = 0;

  wRtn = PCIFC16_SetDIOMode32(wBoardNo,1);
  if(wRtn)
  {
	 printf("\nError Code %d",wRtn);
	   return wRtn;
  }


  //Port A Digital Output 0x5555
  wRtn = PCIFC16_WriteDO(wBoardNo,0,0x5555);
  if(wRtn)
  {
	printf("\nError Code %d",wRtn);
	return wRtn;
  }

  //Port B Digital Input
  wRtn = PCIFC16_ReadDI(wBoardNo,1,&wDIVal);
  if(wRtn)
  {
	printf("\nError Code %d",wRtn);
	return wRtn;
  }

  printf("\n\nPort A OUT 0x5555, Port B In 0x%x \n",wDIVal);

  //Port A Digital Output 0xAAAA
  wRtn = PCIFC16_WriteDO(wBoardNo,0,0xAAAA);
  if(wRtn)
  {
	printf("\nError Code %d",wRtn);
	return wRtn;
  }

  //Port B Digital Input
  wRtn = PCIFC16_ReadDI(wBoardNo,1,&wDIVal);
  if(wRtn)
  {
	printf("\nError Code %d",wRtn);
	return wRtn;
  }

  printf("\n\nPort A OUT 0xAAAA, Port B In 0x%x \n",wDIVal);

  PCIFC16_DriverClose();
}

