/* ----------------------------------------------------------- */
/* DEMO 1 : Digital I/O demo				       */
/* Compiler: Turbo C++ 3.0, Mode Large                         */
/* ----------------------------------------------------------- */

#include "PCIFC16.H"
#include <DOS.H>

DWORD dwBaseAddr,dwBaseDIO,dwBaseTimer0,dwBaseTimer1;
WORD wIrq,wModelID,wCardID;
void main()
{
  int  i;
  WORD wBoards;
  WORD wDIVal,wBoardNo,wRtn;
  WORD wChannelIndex;
  float fFrequency;
  WORD wStatus;
  char c;

  clrscr();
  wRtn=PCIFC16_DriverInit(&wBoards);
  printf("\nThrer are %d PCI-FC16 Cards in this PC",wBoards);
  if ( wBoards==0 )
  {
	putch(0x07);  putch(0x07);  putch(0x07);
	printf("\nThere are no PCI-FC16 card in this PC !!!\n");
	exit(0);
  }
  printf("\n(3) Show the Configuration Space");
  printf("\n Model   BoardNo  BaseAddr   BaseDIO    BaseTimer0  BaseTimer1  IrqNo CardID");
  for(i=0; i<wBoards; i++)
  {
	wRtn = PCIFC16_GetConfigAddressSpace(i,&dwBaseAddr, &dwBaseDIO, &dwBaseTimer0, &dwBaseTimer1, &wIrq, &wModelID, &wCardID);
	if (wRtn) printf("\nGetCardInfo Error!!!");

	printf("\n PCI-%4x   %d   0x%lx  0x%lx  0x%lx  0x%lx  0x%2x  0x%2x",wModelID,i,dwBaseAddr,dwBaseDIO,dwBaseTimer0,dwBaseTimer1,wIrq,wCardID);
  }
  wBoardNo = 0;
  //Set the Total channel
  for(wChannelIndex=0;wChannelIndex<16;wChannelIndex++)
  {

	 wRtn = PCIFC16_SetChannelMode(wBoardNo, wChannelIndex, 0x02, 20); //Read Frequency Mode

	 if(wRtn)
	 {
		printf("\nSet Channel Mode Error!%d" ,wRtn);
		exit(0);
	 }
  }

  printf("\nPlease press any key to measure frequency.");
  getch();

  for(;;)
  {
	  gotoxy(1,6);
	  for(wChannelIndex = 0;wChannelIndex<16;wChannelIndex++)
	  {
		 wRtn = PCIFC16_ReadFrequency(wBoardNo, wChannelIndex, &fFrequency, 20, &wStatus); //Read Frequency
		 if(wRtn)
	 printf(" Read Frequency Error!%d " ,wRtn);
		 printf( "\nCH%2d Freq=%9.3f Hz, status = %d ",wChannelIndex,fFrequency,wStatus);
	  }
	  delay(20);
	  printf("\nPress any key to stop.");
	  if(kbhit()) break;
  }

  getch();

  PCIFC16_DriverClose();
}

