/* --------------------------------------------------------------- */
/* Demo 1: Digital Input of PISO-P64                               */
/* Step 1: The circuit diagram of hardware: refer to Sec 4.2       */
/* Step 2: run demo1.EXE				                           */
/* --------------------------------------------------------------- */

#include <dos.h>
#include "PIO.H"


int main()
{
char c;
BYTE i,r1,r2,r3,r4,r5,r6,r7,r8;
WORD wBoards,wRetVal;
WORD wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;

clrscr();
wRetVal=PIO_DriverInit(&wBoards,0x80,0x08,0x10);  /* for PISO-P64 */
printf("\n(1) Threr are %d PISO-P64 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("\n(1) There are no PISO-P64 card in this PC !!!");
   exit(0);
   }

printf("\n(2) The Configuration Space ->   wBase");

for(i=0; i<wBoards; i++)
   {
    PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,
			     &wSlotBus,&wSlotDevice);
    printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]"
	   ,i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);
   }

/* step 1: enable all D/I/O port       	             */
outportb(wBase,1);	             /* enable D/I/O */

/* step 2: Digital input from DI_0 to DI_63          */
while(1)
{

for ( ; ;)
    {
     printf("\n--------- Digital input of PISO-P64  ------------");
     r1 =inportb(wBase+0xc0);       /* DI_07 to DI_0  */
     r2 =inportb(wBase+0xc4);       /* DI_15 to DI_08 */
     r3 =inportb(wBase+0xc8);	    /* DI_23 to DI_16 */
     r4 =inportb(wBase+0xcc);	    /* DI_31 to DI_24 */

     r5 =inportb(wBase+0xd0);       /* DI_39 to DI_32 */
     r6 =inportb(wBase+0xd4);       /* DI_47 to DI_40 */
     r7 =inportb(wBase+0xd8);	    /* DI_55 to DI_48 */
     r8 =inportb(wBase+0xdc);	    /* DI_63 to DI_56 */

      printf("\nThe CON1 of PISO-P64 ...");
      printf("\nD31- 0 Input Value = %02x,%02x,%02x,%02x\n",r4,r3,r2,r1);

      printf("\nThe CON2 of PISO-P64 ...");
      printf("\nD63-32 Input Value = %02x,%02x,%02x,%02x\n",r8,r7,r6,r5);
      sleep(1);      

    if (kbhit()!=0)
       {
       c=getch();
       if ((c=='q') || (c=='Q') ||  c==27 )
       return;
       }
    delay(1);
    }  /* end of while */
  }   /* end of for */

 PIO_DriverClose();

}
