/* --------------------------------------------------------------------- */
/* Demo 1: Digital Output of PISO_P32C32                                 */
/* Step 1: The circuit diagram of hardware: refer to Sec 4.1             */
/* Step 2: run demo1.EXE                                                 */
/* --------------------------------------------------------------------- */

#include <dos.h>
#include "PIO.H"

int main()
{
char c;
BYTE i;
WORD wBoards,wRetVal;
WORD wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;

clrscr();
wRetVal=PIO_DriverInit(&wBoards,0x80,0x08,0x20);  /* for PISO-P32C32 */
printf("\n(1) Threr are %d PISO-P32C32 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("\n(1) There are no PISO-P32C32 card in this PC !!!");
   exit(0);
   }

printf("\n(2) The Configuration Space ->   wBase");

for(i=0; i<wBoards; i++)
   {
    PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,
                             &wSlotBus,&wSlotDevice);
    printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]"
           ,i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);
   }

/* step 1: enable all D/I/O port                       */
outportb(wBase,1);                   /* enable D/I/O   */

/* step 2: Digital output from DO_0 to DO_31           */
while(1)
{
printf("\n\n --------- Digital output of PISO-P32C32  ------------");
for (i=1;i<=0x80;i=i<<1)
    {
      outportb(wBase+0xc0,i);        /* DO_07 to DO_00 */
      outportb(wBase+0xc4,i);        /* DO_15 to DO_08 */
      outportb(wBase+0xc8,i);        /* DO_23 to DO_16 */
      outportb(wBase+0xcc,i);        /* DO_31 to DO_24 */
      sleep(1);
      printf("\nD 31-0 Output Value = %02x,%02x,%02x,%02x",i,i,i,i);

 if(i==0x80)  { i=0x01; break; }

    if (kbhit()!=0)
       {
       c=getch();
       if ((c=='q') || (c=='Q') ||  c==27 )
       return;
       }
    delay(1);
    }  /* end of while */
  }   /* end of for */

 PIO_DriverClose();

}



