/* --------------------------------------------------------------------- */
/* Demo 1: Digital Ootput of PISO_C64                                     */
/* Step 1: The circuit diagram of hardware: refer to Sec 4.3             */
/* Step 2: run demo1.EXE                                                 */
/* --------------------------------------------------------------------- */

#include <dos.h>
#include "PIO.H"

int main()
{
char c;
BYTE i;
WORD wBoards,wRetVal;
WORD wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;

_clearscreen(0);
wRetVal=PIO_DriverInit(&wBoards,0x80,0x08,0x00);  /* for PISO-C64 */
printf("\n(1) Threr are %d PISO-C64 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("\n(1) There are no PISO-C64 card in this PC !!!");
   exit(0);
   }

printf("\n(2) The Configuration Space ->   wBase");

for(i=0; i<wBoards; i++)
   {
    PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,
                             &wSlotBus,&wSlotDevice);
    printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]"
           ,i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);
   }

/* step 1: enable all D/I/O port                       */
outp(wBase,1);                       /* enable D/I/O   */

/* step 2: Digital output from DO_0 to DO_63           */
while(1)
{
printf("\n\n --------- Digital output of PISO-C64  ------------");
for (i=1;i<=0x80;i=i<<1)
    {
      outp(wBase+0xc0,i);        /* DO_07 to DO_00 */
      outp(wBase+0xc4,i);        /* DO_15 to DO_08 */
      outp(wBase+0xc8,i);        /* DO_23 to DO_16 */
      outp(wBase+0xcc,i);        /* DO_31 to DO_24 */
      outp(wBase+0xd0,i);        /* DO_39 to DO_32 */
      outp(wBase+0xd4,i);        /* DO_47 to DO_40 */
      outp(wBase+0xd8,i);        /* DO_55 to DO_48 */
      outp(wBase+0xdc,i);        /* DO_63 to DO_56 */

      printf("\nThe CON1 of PISO-C64 ...");
      printf("\nD31- 0 Output Value = %02x,%02x,%02x,%02x\n",i,i,i,i);

      printf("\nThe CON2 of PISO-C64 ...");
      printf("\nD63-32 Output Value = %02x,%02x,%02x,%02x\n",i,i,i,i);


 if(i==0x80)  { i=0x01; break; }

    if (kbhit()!=0)
       {
       c=getch();
       if ((c=='q') || (c=='Q') ||  c==27 )
       return;
       }

    }  /* end of while */
  }   /* end of for */

 PIO_DriverClose();

}
