/*-----------------------------------------------------------------------*/
/* Demo 3: Digital I/O test by itself for PISO_P32C32                    */
/* Step 1: The circuit diagram of hardware: refer to Sec 4.1             */
/* Step 2: run demo3.EXE                                                 */
/* --------------------------------------------------------------------- */

#include <dos.h>
#include "PIO.H"


int main()
{
WORD wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
BYTE i,j1,j2,j3,j4;
char c;

WORD wBoards,wRetVal;

_clearscreen(0);
wRetVal=PIO_DriverInit(&wBoards,0x80,0x08,0x20);  /* for PISO-P32C32 */
printf("\n(1) Threr are %d PISO-P32C32 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("\n(1) There are no PISO-P32C32 card in this PC !!!");
   exit(0);
   }

printf("\n(2) The Configuration Space ->   wBase");

for(i=0; i<wBoards; i++)
   {
    PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,
                             &wSlotBus,&wSlotDevice);
    printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]"
           ,i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);
   }

/* step 1: enable all D/I/O port                               */
outp(wBase,1);                   /* enable D/I/O               */

/* step 2: read from DI_0 to DI_31                             */
while(1)
{
printf("\n --------- PISO-P32C32 test by itself ------------");
for (i=1;i<=0x80;i=i<<1)
    {

      outp(wBase+0xc0,i);        /* DO_07 to DO_00 */
      outp(wBase+0xc4,i);        /* DO_15 to DO_08 */
      outp(wBase+0xc8,i);        /* DO_23 to DO_16 */
      outp(wBase+0xcc,i);        /* DO_31 to DO_24 */

      j1=inp(wBase+0xc0)^0xff;   /* DI_07 to DI_00 */
      j2=inp(wBase+0xc4)^0xff;   /* DI_15 to DI_08 */
      j3=inp(wBase+0xc8)^0xff;   /* DI_23 to DI_16 */
      j4=inp(wBase+0xcc)^0xff;   /* DI_31 to DI_24 */


 printf("\nD 31-0 Output Value = %02x,%02x,%02x,%02x",i,i,i,i);
 printf("\nD 31-0 Input  Value = %02x,%02x,%02x,%02x\n",j4,j3,j2,j1);

 if( i != j1 )
   {
    printf("\nDO_7-DO_0 error in here!\n");
    putch(0x07);  putch(0x07);  putch(0x07);
   }
    if( i != j2 )
        {
         printf("\nDO_15-DO_8  error in here!\n");
         putch(0x07);  putch(0x07);  putch(0x07);
        }
     if( i != j3 )
        {
         printf("\nDO_24-DO_16 error in here!\n");
         putch(0x07);  putch(0x07);  putch(0x07);
        }
        if( i != j4 )
        {
         printf("\nDO_31-DO_25 error in here!\n");
         putch(0x07);  putch(0x07);  putch(0x07);
        }

  if(i==j1 & i==j2 & i==j3 & i==j4)
  {
   printf("The Digital I/O test of PISO-P32C32 by itself OK!\n");
  }

 if(i==0x80)  { i=0x01; break; }

    if (kbhit()!=0)
       {
       c=getch();
       if ((c=='q') || (c=='Q') ||  c==27 )
       return;
       }

    }  /* end of while   */
  }

 PIO_DriverClose();

}



