// DEMO2 : D/A Output without calibration                         //
//JP3:0-20mA JP4:-5V JP5:UP  JP6 :INT                             //
//JP7:0-20mA JP8:-5V JP9:UP  JP10:INT                             //                   //
// -------------------------------------------------------------- //

#include "PIO.H"

void PISO_DA2_DA(int iVal);
WORD  wBase,wIrq;
WORD  LSB,MSB,j;

void main()
{
int   i,k;
WORD  wBoards,wRetVal,t1,t2,t3,t4,t5,t6;
WORD  wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
WORD channel;
char  c;

clrscr();

// Step1 : find address-mapping of PIO/PISO cards
wRetVal=PIO_DriverInit(&wBoards,0x80,0x0b,0x00);//for PISO-DA2
printf("\n1. There are %d PISO-DA2 Cards in this PC  *****",wBoards);
if ( wBoards==0 )  exit(0);

printf("\n\n-------------- The Configuration Space --------------");
for(i=0;i<wBoards;i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,&wSlotBus,&wSlotDevice);

   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);

   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }

 PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);     // select card_0 //

// step2 : enable all D/I/O port                                  //
outportb(wBase,0x01);                            // /RESET -> 1   //

printf("\n\n2. A/D Output without calibration test  *****\n\n");
printf("\nPlease make sure of JP5,JP9->UP  JP4,JP8->-5V  JP6,JP10->INT  JP3,JP7->0-20mA\n");

printf("\n<1> Channel 1");
printf("\n<2> Channel 2");
printf("\n<3> Exit");
printf("\nSelect (1-3): \b");
c=getch();
switch(c)
   {
   case '1': MSB=0xc0;
		 LSB=0xc4;
		 channel=1;
		 break;
   case '2': MSB=0xc8;
		 LSB=0xcc;
		 channel=2;
		 break;
   case '3': return;
  default: break;
  }
printf("\n\n   (a) Now Channel-%d output 1.23V",channel);
j=1.23*(4096/5);
PISO_DA2_DA(j);
getch();


printf("\n\n   (b) Now Channel-%d sink 1.23mA",channel);
j=0.306*(4096/5);
PISO_DA2_DA(j);
getch();

outportb(wBase+5,0);                     // Disable all interrupt
outportb(wBase+3,0);                     // All D/O are Low
outportb(wBase+2,0);                     // All AUX as D/I
PIO_DriverClose();
}

// --------------------------------------------------------------
void PISO_DA2_DA(int iVal)
{
 outportb(wBase+MSB,(iVal&0xf00)>>8);
 outportb(wBase+LSB,(iVal&0x0ff));
}
