/*-----------------------------------------------------------------------*/
/* Demo 2: Digital input of PISO_P32C32                                  */
/* Step 1: The circuit diagram of hardware: refer to Sec 4.1             */
/* Step 2: run demo2.EXE                                                 */
/* --------------------------------------------------------------------- */

#include <dos.h>
#include "PIO.H"


int main()
{
WORD wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
BYTE i,j1,j2,j3,j4;
char c;

WORD wBoards,wRetVal;

clrscr();
wRetVal=PIO_DriverInit(&wBoards,0x80,0x08,0x20);  /* for PISO-P32C32 */
printf("\n(1) Threr are %d PISO-P32C32 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("\n(1) There are no PISO-P32C32 card in this PC !!!");
   exit(0);
   }

printf("\n(2) The Configuration Space ->   wBase");

for(i=0; i<wBoards; i++)
   {
    PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,
                             &wSlotBus,&wSlotDevice);
    printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]"
           ,i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);
   }

/* step 1: enable all D/I/O port                           */
outportb(wBase,1);                   /* enable D/I/O       */

/* step 2: digital input from DI_0 to DI_31               */
while(1)
{

for ( ; ; )
    {
      printf("\n\n --------- Digital input of PISO-P32C32 ------------");
      j1=inportb(wBase+0xc0)^0xff;   /* DI_07 to DI_00 */
      j2=inportb(wBase+0xc4)^0xff;   /* DI_15 to DI_08 */
      j3=inportb(wBase+0xc8)^0xff;   /* DI_23 to DI_16 */
      j4=inportb(wBase+0xcc)^0xff;   /* DI_31 to DI_24 */

 printf("\nD 31-0 Input  Value = %02x,%02x,%02x,%02x",j4,j3,j2,j1);
       sleep(1);

    if (kbhit()!=0)
       {
       c=getch();
       if ((c=='q') || (c=='Q') ||  c==27 )
       return;
       }
    delay(1);
    }  /* end of while */
  } /* end of for */

 PIO_DriverClose();

}



