/* DEMO2.C : PISO-730 D/I/O demo                                  */
/* step 1  : connect  DO[0..15] to  DI[0..15],                    */
/*                   IDO[0..15] to IDI[0..15]                     */
/* step 2  : run DEMO2.EXE                                        */
/* -------------------------------------------------------------- */
#include "PIO.H"

void piso_730_do(long lDoValue);
void piso_730_ido(long lDoValue);
long piso_730_di(void);
long piso_730_idi(void);

WORD wBase,wIrq;

int main()
{
int  i,j,k,k1,k2,l1,l2,jj,dd,j1,i1,j2,i2;
WORD wBoards,wRetVal,t1,t2,t3,t4,t5;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
long lOutPad1,lOutPad2,lInPad1,lInPad2;
char c;


clrscr();
/* step 1: find address-mapping of PIO/PISO cards                 */
wRetVal=PIO_DriverInit(&wBoards,0x80,0x08,0x40);  /* for PISO-730 */
printf("\nThrer are %d PISO-730 Cards in this PC",wBoards);
if (wBoards==0) exit(0);

printf("\n--------------- The Configuration Space ---------------");
for(i=0; i<wBoards; i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,
   &wSubAux,&wSlotBus,&wSlotDevice);
   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);
   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }

PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);

/* step 2: enable all D/I/O port                                  */
outportb(wBase,1);                                /* enable D/I/O */

lOutPad1=0x0001;
lOutPad2=0x8000;
for(;;)
   {
   gotoxy(1,8);
   piso_730_do(lOutPad1);
   lInPad1=piso_730_di();

   piso_730_ido(lOutPad2);
   delay(10000);
   lInPad2=piso_730_idi();

   printf("\n DO[0..15]=[%4lx] ,   DI[0..15]=[%4lx]",lOutPad1,lInPad1);
   printf("\nIDO[0..15]=[%4lx] , !IDI[0..15]=[%4lx]",lOutPad2,(~lInPad2&0xffff));

   lOutPad1=(lOutPad1<<1)&0xffff;
   lOutPad2=(lOutPad2>>1)&0xffff;

   if (lOutPad1==0) lOutPad1=1;
   if (lOutPad2==0) lOutPad2=0x8000;

   if (kbhit()!=0) break;
   }
PIO_DriverClose();
}

/* -------------------------------------------------------------- */
void piso_730_do(long lDoValue)
{
outportb(wBase+0xc8,(lDoValue&0xff));
outportb(wBase+0xcc,((lDoValue>>8)&0xff));
}

/* -------------------------------------------------------------- */
void piso_730_ido(long lDoValue)
{
outportb(wBase+0xc0,(lDoValue&0xff));
outportb(wBase+0xc4,((lDoValue>>8)&0xff));
}

/* -------------------------------------------------------------- */
long piso_730_di(void)
{
long lDiValue;
lDiValue=(inportb(wBase+0xcc)<<8);
lDiValue=(lDiValue|(inportb(wBase+0xc8)))&0xffff;
return(lDiValue);
}

/* -------------------------------------------------------------- */
long piso_730_idi(void)
{
long lDiValue;
lDiValue=(inportb(wBase+0xc4)<<8);
lDiValue=(lDiValue|(inportb(wBase+0xc0)))&0xffff;
return(lDiValue);
}

