/* demo 10: Find card number				       */
/* step 1 : run demo10.exe				       */
/* step 2 : connect a 20-pin flat cable to CON2&CON3 of card_? */
/* step 3 : The card number is shown in screen as TEST OK      */
/* ----------------------------------------------------------- */

#include "PCITMC12.H"

WORD pci_tmc12_do(WORD wDo);
void pci_tmc12_di(WORD *wDi);
WORD pci_tmc12_select8254(char cChip);
WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh);
WORD wBaseAddr,wIrq,wPLX;

int main()
{
int  i,j,k;
WORD wBoards,wRetVal;
char c;

clrscr();
wRetVal=PTMC12_DriverInit(&wBoards);
printf("\n(1) Threr are %d PCI-TMC12 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("(1) There are no PCI-TMC12 card in this PC !!!\n"); exit(0);
   }

printf("\n(2) Show the Configuration Space of all PCI-TMC12:");
for(i=0; i<wBoards; i++)
   {
   PTMC12_GetConfigAddressSpace(i,&wBaseAddr,&wIrq,&wPLX);
   printf("\n    Card_%d: wBaseAddr=%x, wIrq=%x, wPLX=%x",i,wBaseAddr,wIrq,wPLX);
   }

PTMC12_GetConfigAddressSpace(0,&wBaseAddr,&wIrq,&wPLX); /* select card_0 */
printf("\n(3) *** Card_0, wBaseAddr=%x ***",wBaseAddr);

for (;;)
    {
    printf("\n------------- press any key to stop -------------");
    for (i=0; i<wBoards; i++) test_card(i);
    for (i=0; i<1000; i++) delay_one_ms();	/* delay 1 sec */
    if (kbhit()!=0) {getch(); break;}
    }

PTMC12_DriverClose();
}

/* ----------------------------------------------------------- */

test_card(int card)
{
int i,j,k,ok;

PTMC12_GetConfigAddressSpace(card,&wBaseAddr,&wIrq,&wPLX);
j=1; ok=1;
for(i=0; i<16; i++)
   {
   pci_tmc12_do(j); pci_tmc12_di(&k);
   if (j!=k) ok=0;
   j=j<<1; if (j==0) j=1;
   }
printf("\nCard Number=%d, wBaseAddr=%x",card,wBaseAddr);
if (ok==1) printf(", Test OK"); else printf(", Test ERROR");
}

/* ----------------------------------------------------------- */

WORD pci_tmc12_do(WORD wDo)
{
outport(wBaseAddr+0x14,wDo);
return(NoError);
}

/* ----------------------------------------------------------- */

void pci_tmc12_di(WORD *wDi)
{
WORD wRetVal;
(*wDi)=(inport(wBaseAddr+0x14))&0xffff;
}


/* CLK-1=8M --> count 0x1f40 = count 8000 = 1 ms		 */
/* down count from 8000 --> 7999 --> ..... --> 1 --> 0 --> 0xfff */
delay_one_ms()
{
int low,high;

pci_tmc12_select8254(0);		/* select 8254-chip-0	       */
pci_tmc12_c0(0x30,0x40,0x1f);		/* CH-1,mode-0 down count 8000 */
for (;;)
    {
    outportb(wBaseAddr+0x0C,0x00);	/* latch counter_0 */
    low=inportb(wBaseAddr);
    high=inportb(wBaseAddr);
    if (high>0x20) return;
    }
}

/* -------------------------------------------------------------------- */

WORD pci_tmc12_select8254(char cChip)
{
outportb(wBaseAddr+0x10,cChip);
return(NoError);
}

WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr     ,cLow);
outportb(wBaseAddr     ,cHigh);
return(NoError);
}

WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr+4   ,cLow);
outportb(wBaseAddr+4   ,cHigh);
return(NoError);
}

WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr+8   ,cLow);
outportb(wBaseAddr+8   ,cHigh);
return(NoError);
}

