/* demo 3 : Square Wave Generator			       */
/* step 1 : all CLK select clock1=8M			       */
/* step 2 : run DEMO3.EXE				       */
/* step 3 : check all Cout of four 8254 by scope	       */
/* ----------------------------------------------------------- */

#include "PCITMC12.H"

WORD pci_tmc12_select8254(char cChip);
WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh);
WORD wBaseAddr,wIrq;

int main()
{
int  i,j;
WORD wBoards,wRetVal,wPLX;
char c;

clrscr();
wRetVal=PTMC12_DriverInit(&wBoards);
printf("\n(1) Threr are %d PCI-TMC12 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("(1) There are no PCI-TMC12 card in this PC !!!\n"); exit(0);
   }

printf("\n(2) Show the Configuration Space of all PCI-TMC12:");
for(i=0; i<wBoards; i++)
   {
   PTMC12_GetConfigAddressSpace(i,&wBaseAddr,&wIrq,&wPLX);
   printf("\n    Card_%d: wBaseAddr=%x, wIrq=%x, wPLX=%x",i,wBaseAddr,wIrq,wPLX);
   }

PTMC12_GetConfigAddressSpace(0,&wBaseAddr,&wIrq,&wPLX); /* select card_0 */
printf("\n(3) *** Card_0, wBaseAddr=%x ***",wBaseAddr);

printf("\n(4) *** Square Wave Generator for CH1 to CH3 ***");
pci_tmc12_select8254(0);   /* select 8254-chip-1			 */
pci_tmc12_c0(0x36,2,0);    /* CH-1,mode-3,low=2,high=0,cout=4M		 */
pci_tmc12_c1(0x76,4,0);    /* CH-2,mode-3,low=4,high=0,cout=2M		 */
pci_tmc12_c2(0xb6,8,0);    /* CH-3,mode-3,low=8,high=0,cout=1M		 */

printf("\n(5) *** Square Wave Generator for CH4 to CH6 ***");
pci_tmc12_select8254(1);   /* select 8254-chip-2			 */
pci_tmc12_c0(0x36,16,0);   /* CH-4,mode-3,low=16,high=0,cout=500K	 */
pci_tmc12_c1(0x76,32,0);   /* CH-5,mode-3,low=32,high=0,cout=250K	 */
pci_tmc12_c2(0xb6,64,0);   /* CH-6,mode-3,low=64,high=0,cout=125K	 */

printf("\n(6) *** Square Wave Generator for CH7 to CH9 ***");
pci_tmc12_select8254(2);   /* select 8254-chip-3			 */
pci_tmc12_c0(0x36,128,0);  /* CH-7,mode-3,low=128,high=0,cout=64K	 */
pci_tmc12_c1(0x76,0,1);    /* CH-8,mode-3,low=0,high=1,cout=32K 	 */
pci_tmc12_c2(0xb6,0,2);    /* CH-9,mode-3,low=0,high=2,cout=16K 	 */

printf("\n(7) *** Square Wave Generator for CH10 to CH12 ***");
pci_tmc12_select8254(3);   /* select 8254-chip-4			 */
pci_tmc12_c0(0x36,0,4);    /* CH-10,mode-3,low=0,high=4,cout=8K 	 */
pci_tmc12_c1(0x76,0,8);    /* CH-11,mode-3,low=0,high=8,cout=4K 	 */
pci_tmc12_c2(0xb6,0,16);   /* CH-12,mode-3,low=0,high=16,cout=2K	 */

PTMC12_DriverClose();
}

/* -------------------------------------------------------------------- */

WORD pci_tmc12_select8254(char cChip)
{
outportb(wBaseAddr+0x10,cChip);
return(NoError);
}

WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr     ,cLow);
outportb(wBaseAddr     ,cHigh);
return(NoError);
}

WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr+4   ,cLow);
outportb(wBaseAddr+4   ,cHigh);
return(NoError);
}

WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr+8   ,cLow);
outportb(wBaseAddr+8   ,cHigh);
return(NoError);
}

