
/* ----------------------------------------------------------- */
/* demo 5 : 16-bit event down counter			       */
/* step 1 : CNT1 select ECLK1 (JP22)			       */
/* step 2 : run demo5.exe				       */
/* step 3 : connect the external CNT signal to pin1 of CON1    */
/* ----------------------------------------------------------- */

#include "PCITMC12.H"

WORD pci_tmc12_select8254(char cChip);
WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh);
WORD wBaseAddr,wIrq,wPLX;

int main()
{
int  i,j;
WORD wBoards,wRetVal;
char c;
unsigned int high,low,count;

clrscr();
wRetVal=PTMC12_DriverInit(&wBoards);
printf("\n(1) Threr are %d PCI-TMC12 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("(1) There are no PCI-TMC12 card in this PC !!!\n"); exit(0);
   }

printf("\n(2) Show the Configuration Space of all PCI-TMC12:");
for(i=0; i<wBoards; i++)
   {
   PTMC12_GetConfigAddressSpace(i,&wBaseAddr,&wIrq,&wPLX);
   printf("\n    Card_%d: wBaseAddr=%x, wIrq=%x, wPLX=%x",i,wBaseAddr,wIrq,wPLX);
   }

PTMC12_GetConfigAddressSpace(0,&wBaseAddr,&wIrq,&wPLX); /* select card_0 */
printf("\n(3) *** Card_0, wBaseAddr=%x ***",wBaseAddr);

printf("\n(4) *** 16-bit event down counter ***\n");

pci_tmc12_select8254(0);		/* select 8254-chip-0	       */
pci_tmc12_c0(0x30,0xff,0xff);		/* CH-1,mode-0 down count ffff */
for (;;)
    {
    outportb(wBaseAddr+0x0C,0x00);	/* latch counter_0 */
    low=inportb(wBaseAddr);
    high=inportb(wBaseAddr);
    count=(0xff-high)*256+(0xff-low)+2;
    printf("\nhigh=%x, low=%x, count=%u",high,low,count);
    if (kbhit()!=0) {getch(); break;}
    }

PTMC12_DriverClose();
}

/* -------------------------------------------------------------------- */

WORD pci_tmc12_select8254(char cChip)
{
outportb(wBaseAddr+0x10,cChip);
return(NoError);
}

WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr     ,cLow);
outportb(wBaseAddr     ,cHigh);
return(NoError);
}

WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr+4   ,cLow);
outportb(wBaseAddr+4   ,cHigh);
return(NoError);
}

WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr+8   ,cLow);
outportb(wBaseAddr+8   ,cHigh);
return(NoError);
}

