/* demo 7 : watchdog timer using CH-3			       */
/* step 1 : CLK-3 select clock2=80K			       */
/* step 2 : J25 select CH3				       */
/* step 3 : run demo7.exe				       */
/* ----------------------------------------------------------- */

#include "PCITMC12.H"

#define A1_8259 0x20
#define A2_8259 0xA0
#define EOI	0x20

WORD pci_tmc12_select8254(char cChip);
WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh);
WORD init_watchdog();
WORD wBaseAddr,wIrq,wPLX;

static void interrupt irq_service();
int watchdog,irqmask;

int main()
{
int  i,j;
WORD wBoards,wRetVal;
char c;
DWORD dwVal;

clrscr();
wRetVal=PTMC12_DriverInit(&wBoards);
printf("\n(1) Threr are %d PCI-TMC12 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("(1) There are no PCI-TMC12 card in this PC !!!\n"); exit(0);
   }

printf("\n(2) Show the Configuration Space of all PCI-TMC12:");
for(i=0; i<wBoards; i++)
   {
   PTMC12_GetConfigAddressSpace(i,&wBaseAddr,&wIrq,&wPLX);
   printf("\n    Card_%d: wBaseAddr=%x, wIrq=%x, wPLX=%x",i,wBaseAddr,wIrq,wPLX);
   }

PTMC12_GetConfigAddressSpace(0,&wBaseAddr,&wIrq,&wPLX); /* select card_0 */
printf("\n(3) *** Card_0, wBaseAddr=%x ***",wBaseAddr);

watchdog=0;
pci_tmc12_select8254(0);		/* select 8254-chip-0		 */
printf("\n(4) *** start refresh watchdog **\n");
init_watchdog();
for (;;)
    {
    refresh_watchdog();
    printf("\npress any key to simulate PC fail, watchdog=%d",watchdog);
    if (kbhit()!=0) {getch(); break;}
    }

printf("\nWait watchdog failure");
for (;;)
    {
    if (watchdog != 0)
       {
       printf("\nwatchdog is failure now");
       break;
       }
    if (kbhit()!=0) {getch(); break;}
    }

PTMC12_DriverClose();
_outpd(wPLX+0x4c,0);	/* disable all interrupt */
}

/* -------------------------------------------------------------------- */

WORD init_watchdog()
{
DWORD dwVal;

disable();

refresh_watchdog();
_outpd(wPLX+0x4c,0x41); 	/* channel_1, interrupt active_Low */

if (wIrq<8)
   {
   irqmask=inportb(A1_8259+1);
   outportb(A1_8259+1,irqmask & (0xff ^ (1 << wIrq)));
   setvect(wIrq+8, irq_service);
   }
else
   {
   irqmask=inportb(A1_8259+1);
   outportb(A1_8259+1,irqmask & 0xfb);			   /* IRQ2 */
   outportb(A1_8259+1,irqmask & (0xff ^ (1 << wIrq)));
   irqmask=inportb(A2_8259+1);
   outportb(A2_8259+1,irqmask & (0xff ^ (1 << (wIrq-8))));
   setvect(wIrq-8+0x70, irq_service);
   }

enable();
}

/* 80K*65536_count=0.8192 sec --> high_width=0.4096 sec    */
/* --> the user has to refresh the watchdog before 0.4 sec */
refresh_watchdog()
{
pci_tmc12_c2(0xb6,0xff,0xff);		/* mode_3, CNT2--> CH3	     */
return(NoError);
}

void interrupt irq_service()
{
watchdog++;
if (wIrq>=8) outportb(A2_8259,0x20);
outportb(A1_8259,0x20);
}

/* -------------------------------------------------------------------- */

WORD pci_tmc12_select8254(char cChip)
{
outportb(wBaseAddr+0x10,cChip);
return(NoError);
}

WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr     ,cLow);
outportb(wBaseAddr     ,cHigh);
return(NoError);
}

WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr+4   ,cLow);
outportb(wBaseAddr+4   ,cHigh);
return(NoError);
}

WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr+8   ,cLow);
outportb(wBaseAddr+8   ,cHigh);
return(NoError);
}

