/* ndemo2 : generate 2 starting clock demo		       */
/* step 1 : all clock sources select external_clock	       */
/* step 2 : run NDEMO2.EXE				       */
/* step 3 : read the counter value of counter1 to counter12    */
/* ----------------------------------------------------------- */

#include "PCITMC12.H"

WORD wBaseAddr,wIrq,wPLX;
WORD pci_tmc12_do(WORD wDo);
WORD pci_tmc12_do2(WORD wXor);
WORD pci_tmc12_select8254(char cChip);
WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh);
void read_c0(int B);
void read_c1(int B);
void read_c2(int B);

int main()
{
int  i,j;
WORD wBoards,wRetVal;
char c;

clrscr();
wRetVal=PTMC12_DriverInit(&wBoards);
printf("\n(1) Threr are %d PCI-TMC12 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("(1) There are no PCI-TMC12 card in this PC !!!\n"); exit(0);
   }

printf("\n(2) Show the Configuration Space of all PCI-TMC12:");
for(i=0; i<wBoards; i++)
   {
   PTMC12_GetConfigAddressSpace(i,&wBaseAddr,&wIrq,&wPLX);
   printf("\n    Card_%d: wBaseAddr=%x, wIrq=%x, wPLX=%x",i,wBaseAddr,wIrq,wPLX);
   }

PTMC12_GetConfigAddressSpace(0,&wBaseAddr,&wIrq,&wPLX); /* select card_0 */
printf("\n(3) *** Card_0 LED test, wBaseAddr=%x ***",wBaseAddr);

/* initial count */

pci_tmc12_select8254(0);
pci_tmc12_c0(0x30,0xfe,0xff);
pci_tmc12_c1(0x70,0xfd,0xff);
pci_tmc12_c2(0xb0,0xfc,0xff);

pci_tmc12_select8254(1);
pci_tmc12_c0(0x30,0xfb,0xff);
pci_tmc12_c1(0x70,0xfa,0xff);
pci_tmc12_c2(0xb0,0xf9,0xff);

pci_tmc12_select8254(2);
pci_tmc12_c0(0x30,0xf8,0xff);
pci_tmc12_c1(0x70,0xf7,0xff);
pci_tmc12_c2(0xb0,0xf6,0xff);

pci_tmc12_select8254(3);
pci_tmc12_c0(0x30,0xf5,0xff);
pci_tmc12_c1(0x70,0xf4,0xff);
pci_tmc12_c2(0xb0,0xf3,0xff);

/* generate 2 starting clocks to all channels (counter1 ~ counter 12) */

delay(1);
pci_tmc12_do2(0);
pci_tmc12_do2(0x0fff);
pci_tmc12_do2(0);
pci_tmc12_do2(0x0fff);
pci_tmc12_do2(0);

for (;;)
    {
    pci_tmc12_select8254(0);
    read_c0(1); /* counter  1 */
    read_c1(2); /* counter  2 */
    read_c2(3); /* counter  3 */

    pci_tmc12_select8254(1);
    read_c0(4); /* counter  4 */
    read_c1(5); /* counter  5 */
    read_c2(6); /* counter  6 */

    pci_tmc12_select8254(2);
    read_c0(7); /* counter  7 */
    read_c1(8); /* counter  8 */
    read_c2(9); /* counter  9 */

    pci_tmc12_select8254(3);
    read_c0(10);/* counter 10 */
    read_c1(11);/* counter 11 */
    read_c2(12);/* counter 12 */

    /* generate one clock to all channels for testing only */
    pci_tmc12_do2(0x0fff);
    pci_tmc12_do2(0);

    printf("\n------------------------");
    c=getch();
    if ((c=='q') || (c=='Q')) return;
    }

PTMC12_DriverClose();
}

/* ----------------------------------------------------------- */

WORD pci_tmc12_do(WORD wDo)
{
outport(wBaseAddr+0x14,wDo);
return(NoError);
}

/* ----------------------------------------------------------- */

WORD pci_tmc12_do2(WORD wXor)
{
outport(wBaseAddr+0x18,wXor);
return(NoError);
}

/* -------------------------------------------------------------------- */

WORD pci_tmc12_select8254(char cChip)
{
outp(wBaseAddr+0x10,cChip);
return(NoError);
}

WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh)
{
outp(wBaseAddr+0x0C,cConfig);
outp(wBaseAddr	   ,cLow);
outp(wBaseAddr	   ,cHigh);
return(NoError);
}

WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh)
{
outp(wBaseAddr+0x0C,cConfig);
outp(wBaseAddr+4   ,cLow);
outp(wBaseAddr+4   ,cHigh);
return(NoError);
}

WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh)
{
outp(wBaseAddr+0x0C,cConfig);
outp(wBaseAddr+8   ,cLow);
outp(wBaseAddr+8   ,cHigh);
return(NoError);
}

/* -------------------------------------------------------------------- */

void read_c0(int B)
{
unsigned int  count,high,low;
char c;

outp(wBaseAddr+0x0c,0);
low=inp(wBaseAddr);
high=inp(wBaseAddr);
count=(0xff-high)*256+(0xff-low);
printf("\nCNT_%2d high=%2x, low=%2x, count=%5u",B,high,low,count);
}

/* -------------------------------------------------------------------- */

void read_c1(int B)
{
unsigned int  count,high,low;
char c;

outp(wBaseAddr+0x0c,0x40);
low=inp(wBaseAddr+4);
high=inp(wBaseAddr+4);
count=(0xff-high)*256+(0xff-low);
printf("\nCNT_%2d high=%2x, low=%2x, count=%5u",B,high,low,count);
}

/* -------------------------------------------------------------------- */

void read_c2(int B)
{
unsigned int  count,high,low;
char c;

outp(wBaseAddr+0x0c,0x80);
low=inp(wBaseAddr+8);
high=inp(wBaseAddr+8);
count=(0xff-high)*256+(0xff-low);
printf("\nCNT_%2d high=%2x, low=%2x, count=%5u",B,high,low,count);
}

