/* demo 3 : Square Wave Generator			       */
/* step 1 : all CLK select clock1=8M			       */
/* step 2 : run DEMO3.EXE				       */
/* step 3 : check all Cout of four 8254 by scope	       */
/* ----------------------------------------------------------- */

#include "PCITMC12.H"

WORD pci_tmc12_select8254(char cChip);
WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh);
WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh);
void pci_tmc12_di(WORD *wDi);
WORD pci_tmc12_do(WORD wDo);
WORD find_h_l(int v, float *h, float *l);

WORD wBaseAddr,wIrq;

int main()
{
int  i,j,count;
WORD wBoards,wRetVal,wPLX;
char c,h,l;
float is_h,is_l;

clrscr();
wRetVal=PTMC12_DriverInit(&wBoards);
printf("\n(1) Threr are %d PCI-TMC12 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("(1) There are no PCI-TMC12 card in this PC !!!\n"); exit(0);
   }

printf("\n(2) Show the Configuration Space of all PCI-TMC12:");
for(i=0; i<wBoards; i++)
   {
   PTMC12_GetConfigAddressSpace(i,&wBaseAddr,&wIrq,&wPLX);
   printf("\n    Card_%d: wBaseAddr=%x, wIrq=%x, wPLX=%x",i,wBaseAddr,wIrq,wPLX);
   }

PTMC12_GetConfigAddressSpace(0,&wBaseAddr,&wIrq,&wPLX); /* select card_0 */
printf("\n(3) *** Card_0, wBaseAddr=%x ***",wBaseAddr);


printf("\n(4) *** Square Wave Generator for CH1 to CH3 ***");
pci_tmc12_select8254(0);   /* select 8254-chip-1			 */
pci_tmc12_c0(0x36,0,32);   /* CH-1,mode-3,low=2,high=0,cout=1K		 */
pci_tmc12_c1(0x76,0,32);   /* CH-2,mode-3,low=4,high=0,cout=1K		 */
pci_tmc12_c2(0xb6,0,32);   /* CH-3,mode-3,low=8,high=0,cout=1K		 */


printf("\n(5) *** Square Wave Generator for CH4 to CH6 ***");
pci_tmc12_select8254(1);   /* select 8254-chip-2			 */
pci_tmc12_c0(0x36,0,32);   /* CH-4,mode-3,low=16,high=0,cout=1K 	 */
pci_tmc12_c1(0x76,0,32);   /* CH-5,mode-3,low=32,high=0,cout=1K 	 */
pci_tmc12_c2(0xb6,0,32);   /* CH-6,mode-3,low=64,high=0,cout=1K 	 */

printf("\n(6) *** Square Wave Generator for CH7 to CH9 ***");
pci_tmc12_select8254(2);   /* select 8254-chip-3			 */
pci_tmc12_c0(0x36,0,32);   /* CH-7,mode-3,low=128,high=0,cout=1K	 */
pci_tmc12_c1(0x76,0,32);   /* CH-8,mode-3,low=0,high=1,cout=1K		 */
pci_tmc12_c2(0xb6,0,32);   /* CH-9,mode-3,low=0,high=2,cout=1K		 */

printf("\n(7) *** Square Wave Generator for CH10 to CH12 ***");
pci_tmc12_select8254(3);   /* select 8254-chip-4			 */
pci_tmc12_c0(0x36,0,32);   /* CH-10,mode-3,low=0,high=4,cout=1K 	 */
pci_tmc12_c1(0x76,0,32);   /* CH-11,mode-3,low=0,high=8,cout=1K 	 */
pci_tmc12_c2(0xb6,0,32);   /* CH-12,mode-3,low=0,high=16,cout=1K	 */

    pci_tmc12_do(0xffff);
    find_h_l(0x01, &is_h, &is_l); printf("\n[ 1] : h=%f, l=%f",is_h,is_l);
    find_h_l(0x02, &is_h, &is_l); printf("\n[ 2] : h=%f, l=%f",is_h,is_l);
    find_h_l(0x04, &is_h, &is_l); printf("\n[ 3] : h=%f, l=%f",is_h,is_l);
    find_h_l(0x08, &is_h, &is_l); printf("\n[ 4] : h=%f, l=%f",is_h,is_l);
    find_h_l(0x10, &is_h, &is_l); printf("\n[ 5] : h=%f, l=%f",is_h,is_l);
    find_h_l(0x20, &is_h, &is_l); printf("\n[ 6] : h=%f, l=%f",is_h,is_l);
    find_h_l(0x40, &is_h, &is_l); printf("\n[ 7] : h=%f, l=%f",is_h,is_l);
    find_h_l(0x80, &is_h, &is_l); printf("\n[ 8] : h=%f, l=%f",is_h,is_l);
    find_h_l(0x100,&is_h, &is_l); printf("\n[ 9] : h=%f, l=%f",is_h,is_l);
    find_h_l(0x200,&is_h, &is_l); printf("\n[10] : h=%f, l=%f",is_h,is_l);
    find_h_l(0x400,&is_h, &is_l); printf("\n[11] : h=%f, l=%f",is_h,is_l);
    find_h_l(0x800,&is_h, &is_l); printf("\n[12] : h=%f, l=%f",is_h,is_l);

PTMC12_DriverClose();
}

/* -------------------------------------------------------------------- */

WORD pci_tmc12_select8254(char cChip)
{
outportb(wBaseAddr+0x10,cChip);
return(NoError);
}

WORD pci_tmc12_c0(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr     ,cLow);
outportb(wBaseAddr     ,cHigh);
return(NoError);
}

WORD pci_tmc12_c1(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr+4   ,cLow);
outportb(wBaseAddr+4   ,cHigh);
return(NoError);
}

WORD pci_tmc12_c2(char cConfig, char cLow, char cHigh)
{
outportb(wBaseAddr+0x0C,cConfig);
outportb(wBaseAddr+8   ,cLow);
outportb(wBaseAddr+8   ,cHigh);
return(NoError);
}

/* ----------------------------------------------------------- */

WORD pci_tmc12_do(WORD wDo)
{
outport(wBaseAddr+0x14,wDo);
return(NoError);
}

/* ----------------------------------------------------------- */

void pci_tmc12_di(WORD *wDi)
{
WORD wRetVal;
(*wDi)=(inport(wBaseAddr+0x14))&0xffff;
}

/* ----------------------------------------------------------- */

WORD find_h_l(int v, float *h, float *l)
{
int  i,j,count;
WORD wBoards,wRetVal,wPLX;
char c;
float hh,ll;

    count=0;
for (;;)	/* 1: find low	*/
    {
    count++;
    pci_tmc12_di(&j); j=j&v;
    if (j==0) break;
    if (count>3000) {(*h)=0; (*l)=0; return;}
    if (kbhit()!=0) {getch(); return;}
    }

    count=0;
for (;;)	/* 2: find high */
    {
    count++;
    pci_tmc12_di(&j); j=j&v;
    if (j!=0) break;
    if (count>3000) {(*h)=0; (*l)=0; return;}
    if (kbhit()!=0) {getch(); return;}
    }

    count=0; hh=0;
for (;;)	/* 3: inc_High & find low  */
    {
    count++; hh++;
    pci_tmc12_di(&j); j=j&v;
    if (j==0) break;
    if (count>3000) {(*h)=0; (*l)=0; return;}
    if (kbhit()!=0) {getch(); return;}
    }

    count=0; ll=0;
for (;;)	/* 4: inc_Low  & find high */
    {
    count++; ll++;
    pci_tmc12_di(&j); j=j&v;
    if (j!=0) break;
    if (count>3000) {(*h)=0; (*l)=0; return;}
    if (kbhit()!=0) {getch(); return;}
    }
(*h)=hh; (*l)=ll;
}

