/* demo 4 : Count high pulse of PC0                               */
/*          (initial High & active Low)                           */
/* step 1 : run DEMO4.EXE                                         */
/* -------------------------------------------------------------- */

#include "PIO.H"

#define A1_8259 0x20
#define A2_8259 0xA0
#define EOI     0x20

WORD init_high();
WORD wBase,wIrq;

static void interrupt irq_service();
int COUNT,irqmask,now_int_state;

int main()
{
int  i,j;
WORD wBoards,wRetVal,t1,t2,t3,t4,t5,t6;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char c;

clrscr();

/* step1 : find address-mapping of PIO/PISO cards                 */
wRetVal=PIO_DriverInit(&wBoards,0x80,0x01,0x40);/* for PIO-D56/D24*/
printf("\n(1) Threr are %d PIO-D56/D24 Cards in this PC",wBoards);
if ( wBoards==0 ) exit(0);

printf("\n\n-------------- The Configuration Space --------------");
for(i=0;i<wBoards;i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,&wSlotBus,&wSlotDevice);

   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);

   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }

PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);

                                                 /* select card_0 */
/* step2 : enable all D/I/O port                                  */
outportb(wBase,1);                                /* /RESET -> 1  */

/* step3 : configure I/O direction                                */
outportb(wBase+0xcc,0x00);               /* set CON3 as D/I ports */

COUNT=0;
init_high();
printf("\n\n***** show the count of Low_pulse *****\n");

for (;;)
    {
    gotoxy(1,7);
    printf("\nCOUNT=%d",COUNT);
    if (kbhit()!=0) break;
    }
outportb(wBase+5,0);                     /* disable all interrupt */

PIO_DriverClose();
}

/* Use PC0 as external interrupt signal                           */
WORD init_high()
{
disable();
outportb(wBase+5,0);                     /* disable all interrupt */
if (wIrq<8)
   {
   irqmask=inportb(A1_8259+1);
   outportb(A1_8259+1,irqmask & 0xff ^ (1<<wIrq));
   setvect(wIrq+8,irq_service);
   }
else
   {
   irqmask=inportb(A1_8259+1);
   outportb(A1_8259+1,irqmask & 0xfb);                     /* IRQ2 */
   irqmask=inportb(A2_8259+1);
   outportb(A2_8259+1,irqmask & 0xff ^ (1<<(wIrq-8)));
   setvect(wIrq-8+0x70,irq_service);
   }

outportb(wBase+5,1);                   /* enable interrupt (PC0)  */
now_int_state=1;                       /* now ini_signal is high  */
outportb(wBase+0x2a,0);                /* select the inverte      */
enable();
}

void interrupt irq_service()
{
if (now_int_state==1)            /* now P2C0 change to low        */
   {                             /* INT_CHAN_0 = !P2C0            */
   COUNT++;
   if ((inportb(wBase+7)&1)==0)  /* P2C0 still fixed in low       */
      {                          /* need to generate a high pulse */
      outportb(wBase+0x2a,1);    /* INV0 select noninverted input */
      now_int_state=0;           /* now P2C0=low                  */
      }
   else now_int_state=1;         /* now P2C0=High                 */
   }
else                             /* now P2C0 change to high       */
   {                             /* INT_CHAN_0 = P2C0             */
   if ((inportb(wBase+7)&1)==1)  /* P2C0 still fixed in high      */
      {                          /* need to generate a high pulse */
      outportb(wBase+0x2a,0);    /* INV0 select inverted input    */
      now_int_state=1;           /* now P2C0=high                 */
      }
   else now_int_state=0;         /* now P2C0=low                  */
   }

if (wIrq>=8) outportb(A2_8259,0x20);
outportb(A1_8259,0x20);
}
