/* demo 4 : Count high pulse of P2C0                              */
/*          (initial High & active Low)                           */
/* step 1 : run DEMO4.EXE                                         */
/* -------------------------------------------------------------- */

#include "PIO.H"

#define A1_8259 0x20
#define A2_8259 0xA0
#define EOI     0x20

WORD init_high();
WORD wBase,wIrq;

static void interrupt irq_service();
int COUNT_L,COUNT_H,irqmask,now_int_state;

int main()
{
int  i,j;
WORD wBoards,wRetVal,t1,t2,t3,t4,t5,t6;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char c;

_clearscreen(0);

/* step1 : find address-mapping of PIO/PISO cards                 */
wRetVal=PIO_DriverInit(&wBoards,0x80,0x01,0x10);   /* for PIO-D96 */
printf("\n(1) Threr are %d PIO-D96 Cards in this PC",wBoards);
if ( wBoards==0 ) exit(0);

printf("\n\n-------------- The Configuration Space --------------");
for(i=0;i<wBoards;i++)
   {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,&wSlotBus,&wSlotDevice);

   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);

   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
   }

PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5);

                                                 /* select card_0 */
/* step2 : enable all D/I/O port                                  */
outp(wBase,1);                                /* /RESET -> 1  */

/* step3 : configure I/O direction                                */
outp(wBase+0xcc,0x00);                /* set CN1 as D/I ports */

init_high();
printf("\n\n***** show the count of Low_pulse *****\n");

for (;;)
    {
    gotoxy(1,7);
    printf("\nCOUNT_L=%d",COUNT_L);
    if (kbhit()!=0) break;
    }
outp(wBase+5,0);                     /* disable all interrupt */

PIO_DriverClose();
}

/* Use P2C0 as external interrupt signal                          */
WORD init_high()
{
_disable();
outp(wBase+5,0);                     /* disable all interrupt */
if (wIrq<8)
   {
   irqmask=inp(A1_8259+1);
   outp(A1_8259+1,irqmask & 0xff ^ (1<<wIrq));
   _dos_setvect(wIrq+8,irq_service);
   }
else
   {
   irqmask=inp(A1_8259+1);
   outp(A1_8259+1,irqmask & 0xfb);                     /* IRQ2 */
   irqmask=inp(A2_8259+1);
   outp(A2_8259+1,irqmask & 0xff ^ (1<<(wIrq-8)));
   _dos_setvect(wIrq-8+0x70,irq_service);
   }

outp(wBase+5,1);                   /* enable interrupt (P2C0) */
now_int_state=1;                       /* now ini_signal is high  */
outp(wBase+0x2a,0);                /* select the inverte      */
_enable();
}

void interrupt irq_service()
{
if (now_int_state==1)            /* now P2C0 change to low        */
   {                             /* INT_CHAN_0 = !P2C0            */
   COUNT_L++;                    /* find a low pulse (P2C0)       */
   if ((inp(wBase+7)&1)==0)  /* P2C0 still fixed in low       */
      {                          /* need to generate a high pulse */
      outp(wBase+0x2a,1);    /* INV0 select noninverted input */
      now_int_state=0;           /* now P2C0=low                  */
      }
   else now_int_state=1;         /* now P2C0=High                 */
   }
else                             /* now P2C0 change to high       */
   {                             /* INT_CHAN_0 = P2C0             */
   COUNT_H++;                    /* find a high pulse (P2C0)      */
   if ((inp(wBase+7)&1)==1)  /* P2C0 still fixed in high      */
      {                          /* need to generate a high pulse */
      outp(wBase+0x2a,0);    /* INV0 select inverted input    */
      now_int_state=1;           /* now P2C0=high                 */
      }
   else now_int_state=0;         /* now P2C0=low                  */
   }
if (wIrq>=8) outp(A2_8259,0x20);
outp(A1_8259,0x20);
}
