// Demo 1 : PIO-D168 D/O demo of CN1                              //
// Step 1 : connect a DB-24C to CN1 of PIO-D168                   //
// Step 2 : run DEMO1.EXE                                         //
// Step 3 : check the LEDs of DB-24C will turn on sequentially    //
// -------------------------------------------------------------- //
#include "PIO.H"

WORD wBase,wIrq;

int main()
{
int  i1,i2,i3;
int i;
WORD wBoards,wRetVal,t1,t2,t3,t4,t5,t6;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char c;
int quit=0;

clrscr();

// step1 : find address-mapping of PIO/PISO cards                 //
wRetVal=PIO_DriverInit(&wBoards,0x80,0x01,0x50);  // for PIO-D168
printf("\n(1) There are %d PIO-D168 Cards in this PC",wBoards);
if ( wBoards==0 ) exit(0);

printf("\n\n-------------- The Configuration Space --------------");
for(i=0;i<wBoards;i++)
  {
   PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,&wSlotBus,&wSlotDevice);

   printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]",i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);

   printf(" --> ");
   ShowPioPiso(wSubVendor,wSubDevice,wSubAux);
  }

PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&t1,&t2,&t3,&t4,&t5); // select card_0

// step2 : enable all D/I/O port                                  //
outportb(wBase,1);                                // /RESET -> 1

// step3 : configuration & initial value setting                  //



outportb(wBase+0xc4,0);        // I/O Port0 is active now
outportb(wBase+0xc0,0);        // sent initial value to Port0
outportb(wBase+0xc4,1);        // I/O Port1 is active now
outportb(wBase+0xc0,0);        // sent initial value to Port1
outportb(wBase+0xc4,2);        // I/O Port2 is active now
outportb(wBase+0xc0,0);        // sent initial value to Port2

outportb(wBase+0xc8,0x38);     // set Port0 to Port2 as DO port
			       //     Port3 to Port5 as DI port
outportb(wBase+0xcc,0x3f);     // set Port6 to Port11 as DI port
outportb(wBase+0xd0,0x3f);     // set Port12 to Port17 as DI port


i=1;
for (;;)
    {
    i1=i&0xff;
    i2=(i>>8)&0xff;
    i3=(i>>16)&0xff;

    outportb(wBase+0xc4,0);
    outportb(wBase+0xc0,i1);

    outportb(wBase+0xc4,1);
    outportb(wBase+0xc0,i2);

    outportb(wBase+0xc4,2);
    outportb(wBase+0xc0,i3);

    gotoxy(1,8);
    printf("\nOutput=[%2x,%2x,%2x]",i3,i2,i1);
    delay(500);

    i=(i<<1)&0xffffff;
    if (i==0) i=1;

    if (kbhit()!=0) return;
    }

PIO_DriverClose();
}
