/* demo 4 : count low  pulse of PC0			       */
/*	    (initial High & active Low) 		       */
/* step 1 : run demo4.exe				       */
/* ----------------------------------------------------------- */

#include "PIO.H"

#define A1_8259 0x20
#define A2_8259 0xA0
#define EOI	0x20

WORD init_high();
WORD wBase,wIrq;

static void interrupt irq_service();
int COUNT,irqmask,now_int_state;

int main()
{
int  i,j;
WORD wBoards;
WORD wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char c;
DWORD dwVal;

clrscr();
PIO_DriverInit(&wBoards,0x80,0x01,0x00);
printf("\n(1) Threr are %d PIO-D144 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("(1) There are no PIO-D144 card in this PC !!!\n"); exit(0);
   }

printf("\n(2) Show the Configuration Space of all PIO-D144:");
for(i=0; i<wBoards; i++)
   {
    PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,
			     &wSlotBus,&wSlotDevice);
    printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]"
	   ,i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);

   }

/* select card_0 */
PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,
			     &wSlotBus,&wSlotDevice);

printf("\n(3) *** Card_0, wBaseAddr=%x ***",wBase);

COUNT=0;
outp(wBase+0xc8,0xff);    /* CN1 to CN2 port are all input      */
printf("\n(4) *** show the count of High_pulse **\n");
init_high();

for (;;)
    {
    printf("\nCOUNT=%d",COUNT);
    if (kbhit()!=0) {getch(); break;}
    }

outp(wBase+5,0);		/* disable all interrupt */
PIO_DriverClose();
}

/* -------------------------------------------------------------------- */
/* Use PC0 as external interrupt signal 				*/
WORD init_high()
{
DWORD dwVal;

disable();

outp(wBase+5,0);		/* disable all interrupt */
if (wIrq<8)
   {
   irqmask=inp(A1_8259+1);
   outp(A1_8259+1,irqmask & (0xff ^ (1 << wIrq)));
   setvect(wIrq+8, irq_service);
   }
else
   {
   irqmask=inp(A1_8259+1);
   outp(A1_8259+1,irqmask & 0xfb);			   /* IRQ2 */
   outp(A1_8259+1,irqmask & (0xff ^ (1 << wIrq)));
   irqmask=inp(A2_8259+1);
   outp(A2_8259+1,irqmask & (0xff ^ (1 << (wIrq-8))));
   setvect(wIrq-8+0x70, irq_service);
   }

outp(wBase+5,1);		/* enable interrupt		   */
now_int_state=1;		/* now int_signal is low	   */
outp(wBase+0x2a,1); 	/* select the inverte input	   */
enable();
}

void interrupt irq_service()
{
if (now_int_state==0)
   {
				   /* find a high_pulse here	      */
   outp(wBase+0x2a,1);	   /* select the inverte input	      */
   now_int_state=1;		   /* now int_signal is High	      */
   }
else
   {
   COUNT++;			   /* find a low_pulse		      */
   outp(wBase+0x2a,0);	   /* select the non-inverte input    */
   now_int_state=0;		   /* now int_signal is High	      */
   }

if (wIrq>=8) outp(A2_8259,0x20);
outp(A1_8259,0x20);
}

