/* ----------------------------------------------------------- */
/* demo 5 : four interrupt source			       */
/*	    CN1_PC0: initial Low, active High		       */
/*	    CN1_PC1: initial High, active Low		       */
/*	    CN1_PC2: initial Low, active High		       */
/*	    CN1_PC3: initial High, active Low		       */
/* step 1 : run demo5.exe				       */
/* ----------------------------------------------------------- */

#include "PIO.H"

#define A1_8259 0x20
#define A2_8259 0xA0
#define EOI	0x20

WORD init_low();
WORD wBase,wIrq;

static void interrupt irq_service();
int  irqmask,now_int_state,invert,new_int_state,int_c,int_num;
int  CNT_L1,CNT_L2,CNT_L3,CNT_L4;
int  CNT_H1,CNT_H2,CNT_H3,CNT_H4;

int main()
{
int  i,j;
WORD wBoards,wRetVal;
WORD wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice;
char c;
DWORD dwVal;

clrscr();
PIO_DriverInit(&wBoards,0x80,0x01,0x00);
printf("\n(1) Threr are %d PIO-D144 Cards in this PC",wBoards);
if ( wBoards==0 )
   {
   putch(0x07);  putch(0x07);  putch(0x07);
   printf("(1) There are no PIO-D144 card in this PC !!!\n"); exit(0);
   }

printf("\n(2) Show the Configuration Space of all PIO-D144:");
for(i=0; i<wBoards; i++)
   {
    PIO_GetConfigAddressSpace(i,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,
			     &wSlotBus,&wSlotDevice);
    printf("\nCard_%d: wBase=%x,wIrq=%x,subID=[%x,%x,%x],SlotID=[%x,%x]",
	   i,wBase,wIrq,wSubVendor,wSubDevice,wSubAux,wSlotBus,wSlotDevice);
    }

/* select card_0 */
PIO_GetConfigAddressSpace(0,&wBase,&wIrq,&wSubVendor,&wSubDevice,&wSubAux,
			     &wSlotBus,&wSlotDevice);

printf("\n(3) *** Card_0, wBaseAddr=%x ***",wBase);

outp(wBase+0xc8,0xff);    /* CN1 to CN2 port are all input      */
printf("\n(4) *** show the count of High_pulse **\n");
init_low();

for (;;)
    {
    printf("\n(CNT_L, CNT_H) = (%d,%d) (%d,%d) (%d,%d) (%d,%d) %x",
	    CNT_L1,CNT_H1,CNT_L2,CNT_H2,CNT_L3,CNT_H3,CNT_L4,CNT_H4, int_num);
    if (kbhit()!=0) {getch(); break;}
    }

outp(wBase+5,0);		/* disable all interrupt */
PIO_DriverClose();
}

/* -------------------------------------------------------------------- */
/* Use PC0 as external interrupt signal 				*/

WORD init_low()
{
DWORD dwVal;

disable();

outp(wBase+5,0);		/* disable all interrupt */
if (wIrq<8)
   {
   irqmask=inp(A1_8259+1);
   outp(A1_8259+1,irqmask & (0xff ^ (1 << wIrq)));
   setvect(wIrq+8, irq_service);
   }
else
   {
   irqmask=inp(A1_8259+1);
   outp(A1_8259+1,irqmask & 0xfb);			   /* IRQ2 */
   outp(A1_8259+1,irqmask & (0xff ^ (1 << wIrq)));
   irqmask=inp(A2_8259+1);
   outp(A2_8259+1,irqmask & (0xff ^ (1 << (wIrq-8))));
   setvect(wIrq-8+0x70, irq_service);
   }


invert=0x05;
outp(wBase+0x2a,invert);	/*     CN1_PC0 = non-inverte input */
				/*     CN1_PC1 =     inverte input */
				/*     CN1_PC2 = non-inverte input */
				/*     CN1_PC3 = non-inverte input */
now_int_state=0x0a;		/* Now CN1_PC0 = low		   */
				/*     CN1_PC1 = high		   */
				/*     CN1_PC2 = low		   */
				/*     CN1_PC3 = high		   */
CNT_L1=CNT_L2=CNT_L3=CNT_L4=0;	/* low pulse count		   */
CNT_H1=CNT_H2=CNT_H3=CNT_H4=0;	/* high pulse count		   */
int_num=0;
outp(wBase+5,0x0f); 	/* enable interrupt PC0,PC1,PC2,PC3 of CN1 */
enable();
}

void interrupt irq_service()
{
char cc;

int_num++;
new_int_state=inp(wBase+0x07)&0xff;
int_c=new_int_state ^ now_int_state;

if ((int_c&0x01) != 0)
   {
   cc=new_int_state&0x01;
   if (cc !=0) CNT_H1++; else CNT_L1++;
   invert=invert ^ 1;
   }

if ((int_c&0x02) != 0)
   {
   cc=new_int_state&0x02;
   if (cc !=0) CNT_H2++; else CNT_L2++;
   invert=invert ^ 2;
   }

if ((int_c&0x04) != 0)
   {
   cc=new_int_state&0x04;
   if (cc !=0) CNT_H3++; else CNT_L3++;
   invert=invert ^ 4;
   }

if ((int_c&0x08) != 0)
   {
   cc=new_int_state&0x08;
   if (cc !=0) CNT_H4++; else CNT_L4++;
   invert=invert ^ 8;
   }

now_int_state=new_int_state;
outp(wBase+0x2a,invert);

if (wIrq>=8) outp(A2_8259,0x20);
outp(A1_8259,0x20);
}

